/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <hamsandwich>
#include <metahook>
#include <cs_ham_bots_api>

#include <cspb_core>

#define PLUGIN "[CSPB]Tab Score"
#define VERSION CSPB_VERSION
#define AUTHOR CSPB_DEVELOPER

#define X_RANK_POS_T 0.20975
#define X_RANK_POS_CT 0.575
#define Y_RANK_POS 0.2975
#define Y_RANK_RANGE 0.0340

new targaFile[] = "gfx\\hud\\tab_score";
new RankTarga[] = "gfx\\rank\\";

new szRank[33][64];


public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	RegisterHam(Ham_Spawn, "player", "fwd_Spawn", 0);
	RegisterHamBots(Ham_Spawn, "fwd_Spawn", 0);
	
	register_clcmd("cspb_rank", "ClCmd_Rank");
	register_clcmd("+cspb_tabscore", "ClCmd_Tab");
	register_clcmd("-cspb_tabscore", "ClCmd_UnTab");
}

public fwd_Spawn(iIndex)
{
	new iDiff = get_cvar_num("bot_difficulty");
	
	if (!is_user_bot(iIndex))
	{
		if (equal(szRank[iIndex], ""))
		{
			format(szRank[iIndex], sizeof szRank, "%s0", RankTarga);
		}
	}
	
	if (iDiff == 0)
	{
		format(szRank[iIndex], sizeof szRank, "%s%d", RankTarga, random_num(0, 4));
	}
	else if (iDiff == 1)
	{
		format(szRank[iIndex], sizeof szRank, "%s%d", RankTarga, random_num(5, 30));
	}
	else if (iDiff == 2)
	{
		format(szRank[iIndex], sizeof szRank, "%s%d", RankTarga, random_num(31, 45));
	}
	else if (iDiff >= 4)
	{
		format(szRank[iIndex], sizeof szRank, "%s%d", RankTarga, random_num(46, 50));
	}
}

public ClCmd_Rank(iIndex)
{
	new szCmd[33];
	read_argv(1, szCmd, sizeof szCmd);
	
	format(szRank[iIndex], sizeof szRank, "%s%s", RankTarga, szCmd);
}

public ClCmd_Tab(iIndex)
{
	InitializeTabScore(iIndex, 1000.0);
	return PLUGIN_HANDLED;
}

public ClCmd_UnTab(iIndex)
{
	InitializeTabScore(iIndex, 0.0);
	return PLUGIN_HANDLED;
}

public SortFuncT(iIndex1, iIndex2)
{
	new iFrags1 = get_user_frags(iIndex1);
	new iFrags2 = get_user_frags(iIndex2);
	
	if (iFrags1 > iFrags2) return -1;
	else if (iFrags1 < iFrags2) return 1;
	else if (iFrags1 < iFrags2) return -1;
	else if (iFrags1 > iFrags2) return 1;
	
	return 0;
}

public SortFuncCT(iIndex1, iIndex2)
{
	new iFrags1 = get_user_frags(iIndex1);
	new iFrags2 = get_user_frags(iIndex2);
	
	if (iFrags1 > iFrags2) return -1;
	else if (iFrags1 < iFrags2) return 1;
	else if (iFrags1 < iFrags2) return -1;
	else if (iFrags1 > iFrags2) return 1;
	
	return 0;
}

InitializeTabScore(iIndex, Float:flTime)
{
	new Float:flTCoordinateNameX = 0.245;
	new Float:flCTCoordinateNameX = 0.610;
	new Float:flTCoordinateFragsX = 0.4025;
	new Float:flCTCoordinateFragsX = 0.7695;
	new Float:flTCoordinateDeathsX = 0.440;
	new Float:flCTCoordinateDeathsX = 0.8070;
	new Float:flY = 0.3025;
	new Float:flYRange = 0.0340;
	
	MH_DrawTargaImage(iIndex, targaFile, 1, 1, 255, 255, 255, 0.5, 0.5, 0, 100, flTime);
	
	new szTName[8][33], szCTName[8][33], iTFrags[33], szTFrags[8][33], iCTFrags[33], szCTFrags[8][33], iTDeaths[33], szTDeaths[8][33], iCTDeaths[33], szCTDeaths[8][33];
	
	new iTs[32], iTNum, iT;
	get_players(iTs, iTNum, "e", "TERRORIST");
	SortCustom1D(iTs, iTNum, "SortFuncT");
	
	for (new i = 0 ; i < iTNum ; ++i)
	{
		iT = iTs[i];
		
		if (is_user_connected(iT)) 
		{
			get_user_name(iT, szTName[i], sizeof szTName);
			iTFrags[iT] = get_user_frags(iT);
			iTDeaths[iT] = get_user_deaths(iT);
			num_to_str(iTFrags[iT], szTFrags[i], sizeof szTFrags);
			num_to_str(iTDeaths[iT], szTDeaths[i], sizeof szTDeaths);
			
			MH_DrawTargaImage(iIndex, szRank[iT], 1, 1, 255, 255, 255, X_RANK_POS_T, Y_RANK_POS + i * Y_RANK_RANGE, 0, 101 + i, flTime);
			
			MH_DrawFontText(iIndex, szTName[i], 1, flTCoordinateNameX, flY + i * flYRange, 255, 255, 255, 12, flTime, 0.0, 0, 100 + i);
			MH_DrawFontText(iIndex, szTFrags[i], 1, flTCoordinateFragsX, flY + i * flYRange, 255, 255, 255, 12, flTime, 0.0, 0, 100 + i);
			MH_DrawFontText(iIndex, szTDeaths[i], 1, flTCoordinateDeathsX, flY + i * flYRange, 255, 255, 255, 12, flTime, 0.0, 0, 100 + i);
		}
	}
	
	new iCTs[32], iCTNum, iCT;
	get_players(iCTs, iCTNum, "e", "CT");
	SortCustom1D(iCTs, iCTNum, "SortFuncCT");
	
	for (new i = 0 ; i < iCTNum ; ++i)
	{
		iCT = iCTs[i];
		
		if (is_user_connected(iCT)) 
		{
			get_user_name(iCT, szCTName[i], sizeof szCTName);
			iCTFrags[iCT] = get_user_frags(iCT);
			iCTDeaths[iCT] = get_user_deaths(iCT);
			num_to_str(iCTFrags[iCT], szCTFrags[i], sizeof szCTFrags);
			num_to_str(iCTDeaths[iT], szCTDeaths[i], sizeof szCTDeaths);
			
			MH_DrawTargaImage(iIndex, szRank[iCT], 1, 1, 255, 255, 255, X_RANK_POS_CT, Y_RANK_POS + i * Y_RANK_RANGE, 0, 110 + i, flTime);
			
			MH_DrawFontText(iIndex, szCTName[i], 1, flCTCoordinateNameX, flY + i * flYRange, 255, 255, 255, 12, flTime, 0.0, 0, 100 + i);
			MH_DrawFontText(iIndex, szCTFrags[i], 1, flCTCoordinateFragsX, flY + i * flYRange, 255, 255, 255, 12, flTime, 0.0, 0, 100 + i);
			MH_DrawFontText(iIndex, szCTDeaths[i], 1, flCTCoordinateDeathsX, flY + i * flYRange, 255, 255, 255, 12, flTime, 0.0, 0, 100+ i);
		}
	}
}
